/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

if exists(select * from sys.sysprocedure where proc_name = 'ASQLCloneCPFFormulaRecord') then 
   drop procedure ASQLCloneCPFFormulaRecord;
end if;

CREATE PROCEDURE "DBA"."ASQLCloneCPFFormulaRecord"(
in In_FormulaId char(20),
in In_FromFormulaId char(20))
begin
  declare In_FormulaActive integer;
  declare In_FormulaPreprocess integer;
  declare In_FormulaRecurring integer;
  declare In_FormulaCategory char(20);
  declare In_FormulaSubCategory char(20);
  declare In_FormulaType char(20);
  declare In_FormulaRangeBasis char(20);
  declare In_FormulaDesc char(255);
  declare In_Maximum double;
  declare In_Minimum double;
  declare In_Formula char(255);
  declare In_Constant1 double;
  declare In_Constant2 double;
  declare In_Constant3 double;
  declare In_Constant4 double;
  declare In_Constant5 double;
  declare In_Keywords1 char(20);
  declare In_Keywords2 char(20);
  declare In_Keywords3 char(20);
  declare In_Keywords4 char(20);
  declare In_Keywords5 char(20);
  declare In_Keywords6 char(20);
  declare In_Keywords7 char(20);
  declare In_Keywords8 char(20);
  declare In_Keywords9 char(20);
  declare In_Keywords10 char(20);
  declare In_UserDef1 char(20);
  declare In_UserDef2 char(20);
  declare In_UserDef3 char(20);
  declare In_UserDef4 char(20);
  declare In_UserDef5 char(20);
  declare In_F1 char(20);
  declare In_F2 char(20);
  declare In_F3 char(20);
  declare In_F4 char(20);
  declare In_F5 char(20);
  declare In_F6 char(20);
  declare In_F7 char(20);
  declare In_F8 char(20);
  declare In_F9 char(20);
  declare In_F10 char(20);
  declare In_P1 char(20);
  declare In_P2 char(20);
  declare In_P3 char(20);
  declare In_P4 char(20);
  declare In_P5 char(20);
  declare In_P6 char(20);
  declare In_P7 char(20);
  declare In_P8 char(20);
  declare In_P9 char(20);
  declare In_P10 char(20);
  /*
  Create Formula Record
  */
  select FormulaActive,
    FormulaPreprocess,
    FormulaRecurring,
    FormulaCategory,
    FormulaSubCategory,
    FormulaType,
    FormulaRangeBasis,
    FormulaDesc into In_FormulaActive,
    In_FormulaPreprocess,
    In_FormulaRecurring,
    In_FormulaCategory,
    In_FormulaSubCategory,
    In_FormulaType,
    In_FormulaRangeBasis,
    In_FormulaDesc from Formula where
    FormulaId = In_FromFormulaId;
  call InsertNewFormula(In_FormulaId,
  In_FormulaActive,
  In_FormulaPreprocess,
  In_FormulaRecurring,
  In_FormulaCategory,
  In_FormulaSubCategory,
  In_FormulaType,
  In_FormulaRangeBasis,
  In_FormulaDesc,'');
  /*
  Create Formula Range Record
  */
  select Maximum as In_Maximum,
    Minimum as Minimum,
    Formula as Formula,
    Constant1 as Constant1,
    Constant2 as Constant2,
    Constant3 as Constant3,
    Constant4 as Constant4,
    Constant5 as Constant5,
    Keywords1 as Keywords1,
    Keywords2 as Keywords2,
    Keywords3 as Keywords3,
    Keywords4 as Keywords4,
    Keywords5 as Keywords5,
    Keywords6 as Keywords6,
    Keywords7 as Keywords7,
    Keywords8 as Keywords8,
    Keywords9 as Keywords9,
    Keywords10 as Keywords10,
    UserDef1 as UserDef1,
    UserDef2 as UserDef2,
    UserDef3 as UserDef3,
    UserDef4,
    UserDef5,
    F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,
    P1,P2,P3,P4,P5,P6,P7,P8,P9,P10 into In_Maximum,
    In_Minimum,
    In_Formula,
    In_Constant1,
    In_Constant2,
    In_Constant3,
    In_Constant4,
    In_Constant5,
    In_Keywords1,
    In_Keywords2,
    In_Keywords3,
    In_Keywords4,
    In_Keywords5,
    In_Keywords6,
    In_Keywords7,
    In_Keywords8,
    In_Keywords9,
    In_Keywords10,
    In_UserDef1,
    In_UserDef2,
    In_UserDef3,
    In_UserDef4,
    In_UserDef5,
    In_F1,In_F2,In_F3,In_F4,In_F5,In_F6,In_F7,In_F8,In_F9,In_F10,
    In_P1,In_P2,In_P3,In_P4,In_P5,In_P6,In_P7,In_P8,In_P9,
    In_P10 from
    FormulaRange where
    FormulaRangeId = 1 and FormulaId = In_FromFormulaId;
  call InsertNewFormulaRange(
  1,
  In_FormulaId,
  In_Maximum,
  In_Minimum,
  In_Formula,
  In_Constant1,
  In_Constant2,
  In_Constant3,
  In_Constant4,
  In_Constant5,
  In_Keywords1,
  In_Keywords2,
  In_Keywords3,
  In_Keywords4,
  In_Keywords5,
  In_Keywords6,
  In_Keywords7,
  In_Keywords8,
  In_Keywords9,
  In_Keywords10,
  In_UserDef1,
  In_UserDef2,
  In_UserDef3,
  In_UserDef4,
  In_UserDef5,
  In_F1,In_F2,In_F3,In_F4,In_F5,In_F6,In_F7,In_F8,In_F9,In_F10,
  In_P1,In_P2,In_P3,In_P4,In_P5,In_P6,In_P7,In_P8,In_P9,In_P10)
end;

/*-------------------------------------------------------------------------------------*/
/* To insert Malaysia EPF changes effective Jan 2021 */
/*-------------------------------------------------------------------------------------*/
if not exists(select * from CPFPolicy where CPFPolicyId = 'EPFYr2021Jan') then
	Insert into CPFPolicy (CPFPolicyId, CPFGovernment, CPFPolicyDesc) Values('EPFYr2021Jan',1,'13% Employer,9% Employee');
	Update SubRegistry Set ShortStringAttr = 'EPFYr2021Jan' Where RegistryId = 'PaySetupData' and SubRegistryId = 'EPFProgPolicyId';

	/* Insert EPF Table for EP21ST */
	if not exists(select * from CPFTableCode where CPFTableCodeId = 'EP21ST') then
		Insert into CPFTableCode (CPFTableCodeId, CPFResidenceTypeId, CPFSchemeId, CPFTableDesc, CPFPeriodCapping, CPFLessThanCapping, CPFGreaterThanCapping) Values('EP21ST','Local','EPFMandatory','Malaysian Standard Rate - Employer 13% and Employee 9%',0,0,0);
		Insert into CPFPolicyMember (CPFPolicyId, CPFTableCodeId) Values('EPFYr2021Jan','EP21ST');
	end if;

	/* Insert EPF Table for EP21PR */
	if not exists(select * from CPFTableCode where CPFTableCodeId = 'EP21PR') then
		Insert into CPFTableCode (CPFTableCodeId, CPFResidenceTypeId, CPFSchemeId, CPFTableDesc, CPFPeriodCapping, CPFLessThanCapping, CPFGreaterThanCapping) Values('EP21PR','PR','EPFMandatory','PR Standard Rate - Employer 13% and Employee 9%',0,0,0);
		Insert into CPFPolicyMember (CPFPolicyId, CPFTableCodeId) Values('EPFYr2021Jan','EP21PR');
	end if;

	/* Insert EPF Table for EP21EX */
	if not exists(select * from CPFTableCode  where CPFTableCodeId = 'EP21EX') then
		Insert into CPFTableCode (CPFTableCodeId, CPFResidenceTypeId, CPFSchemeId, CPFTableDesc, CPFPeriodCapping, CPFLessThanCapping, CPFGreaterThanCapping) Values('EP21EX','FW','EPFMandatory','Foreign Workers and Expatriates Rate - Employer RM5 and Employee 9% ',0,0,0);
		Insert into CPFPolicyMember (CPFPolicyId, CPFTableCodeId) Values('EPFYr2021Jan','EP21EX');
	end if;

	/*========== Create Formula for EP21ST ===========*/
	if not exists(select * from Formula where Locate(FormulaId,'EP21ST') = 1 and FormulaCategory = 'EPFFormula') then

		/* Insert Formula ER Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$10ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$5000ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$10ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$5000ERM',1,0,0,'EPFFormula','ER','T1','','','','','');

		/* Insert Formula EE Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$10EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$5000EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$10EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$5000EEM',1,0,0,'EPFFormula','EE','T4','','','','','');

		/* Insert Formula ER Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$5000ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$5000ERV',1,0,0,'EPFFormula','ER','T1','','','','','');

		/* Insert Formula EE Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA0$5000EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21STA60$5000EEV',1,0,0,'EPFFormula','EE','T1','','','','','');

		/* Insert FormulaRange ER Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$10ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',13,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$5000ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',12,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$10ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@RNDNEAR(K1,100)),@RNDNEAR(K1,20))/100);',4,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFRoundNear','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$5000ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@RNDNEAR(K1,100)),@RNDNEAR(K1,20))/100);',4,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFRoundNear','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange EE Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$10EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',9,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$5000EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',9,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$10EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$5000EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange ER Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$5000ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$5000ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange EE Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA0$5000EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21STA60$5000EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert EPF Table Component */
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',0,0,'EP21STA0$0EEM','EP21STA0$0ERM',10,60,'EP21STA0$0EEV','EP21STA0$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',10,0,'EP21STA0$10EEM','EP21STA0$10ERM',5000,60,'EP21STA0$10EEV','EP21STA0$10ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',5000,0,'EP21STA0$5000EEM','EP21STA0$5000ERM',9999999,60,'EP21STA0$5000EEV','EP21STA0$5000ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',0,60,'EP21STA60$0EEM','EP21STA60$0ERM',10,75,'EP21STA60$0EEV','EP21STA60$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',10,60,'EP21STA60$10EEM','EP21STA60$10ERM',5000,75,'EP21STA60$10EEV','EP21STA60$10ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21ST',5000,60,'EP21STA60$5000EEM','EP21STA60$5000ERM',9999999,75,'EP21STA60$5000EEV','EP21STA60$5000ERV');

	end if;

	/*========== Create Formula for EP21PR ===========*/
	if not exists(select * from Formula where Locate(FormulaId,'EP21PR') = 1 and FormulaCategory = 'EPFFormula') then

		/* Insert Formula ER Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$10ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$5000ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$10ERM',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$5000ERM',1,0,0,'EPFFormula','ER','T1','','','','','');

		/* Insert Formula EE Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$10EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$5000EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$10EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$5000EEM',1,0,0,'EPFFormula','EE','T1','','','','','');

		/* Insert Formula ER Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$5000ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$5000ERV',1,0,0,'EPFFormula','ER','T1','','','','','');

		/* Insert Formula EE Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA0$5000EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21PRA60$5000EEV',1,0,0,'EPFFormula','EE','T1','','','','','');

		/* Insert FormulaRange ER Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$10ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',13,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$5000ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',12,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$10ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',6.5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$5000ERM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',6,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
	
		/* Insert FormulaRange EE Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$10EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',9,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$5000EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',9,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$10EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',5.5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$5000EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@IF(K5>5000,@RNDNEAR(K1,100),K1)),@RNDNEAR(K1,20))/100);',5.5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFNoRounding','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange ER Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$5000ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$5000ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange EE Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA0$5000EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21PRA60$5000EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert EPF Table Component */
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',0,0,'EP21PRA0$0EEM','EP21PRA0$0ERM',10,60,'EP21PRA0$0EEV','EP21PRA0$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',10,0,'EP21PRA0$10EEM','EP21PRA0$10ERM',5000,60,'EP21PRA0$10EEV','EP21PRA0$10ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',5000,0,'EP21PRA0$5000EEM','EP21PRA0$5000ERM',9999999,60,'EP21PRA0$5000EEV','EP21PRA0$5000ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',0,60,'EP21PRA60$0EEM','EP21PRA60$0ERM',10,75,'EP21PRA60$0EEV','EP21PRA60$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',10,60,'EP21PRA60$10EEM','EP21PRA60$10ERM',5000,75,'EP21PRA60$10EEV','EP21PRA60$10ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21PR',5000,60,'EP21PRA60$5000EEM','EP21PRA60$5000ERM',9999999,75,'EP21PRA60$5000EEV','EP21PRA60$5000ERV');

	end if;

	/*========== Create Formula for EP21EX ===========*/
	if not exists(select * from Formula where Locate(FormulaId,'EP21EX') = 1 and FormulaCategory = 'EPFFormula') then

		/* Insert Formula ER Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$10ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$0ERM',1,0,0,'EPFFormula','ER','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$10ERM',1,0,0,'EPFFormula','ER','T4','','','','','');

		/* Insert Formula EE Mandatory */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$10EEM',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$0EEM',1,0,0,'EPFFormula','EE','T4','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$10EEM',1,0,0,'EPFFormula','EE','T1','','','','','');

		/* Insert Formula ER Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$0ERV',1,0,0,'EPFFormula','ER','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$10ERV',1,0,0,'EPFFormula','ER','T1','','','','','');

		/* Insert Formula EE Voluntary */
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA0$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$0EEV',1,0,0,'EPFFormula','EE','T1','','','','','');
		Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('EP21EXA60$10EEV',1,0,0,'EPFFormula','EE','T1','','','','','');

		/* Insert FormulaRange ER Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$10ERM',1,0,0,'C1;',5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$0ERM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$10ERM',1,0,0,'C1;',5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange EE Mandatory */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$10EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@RNDNEAR(K1,100)),@RNDNEAR(K1,20))/100);',9,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFRoundNear','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$0EEM',1,0,0,'C1;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$10EEM',1,0,0,'@CEILING((C1)*@IF(K1>5000,@IF(K1>20000,(K1),@RNDNEAR(K1,100)),@RNDNEAR(K1,20))/100);',5.5,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','CEILING','RNDNEAR','EPFRoundNear','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange ER Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$0ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$10ERV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert FormulaRange EE Voluntary */
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA0$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$0EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('EP21EXA60$10EEV',1,0,0,'0;',0,0,0,0,0,'MandatoryWage','VolEPF','VoluntaryWage','VolEPFAmt','NonBonusWage','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');

		/* Insert EPF Table Component */
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21EX',0,0,'EP21EXA0$0EEM','EP21EXA0$0ERM',10,60,'EP21EXA0$0EEV','EP21EXA0$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21EX',10,0,'EP21EXA0$10EEM','EP21EXA0$10ERM',9999999,60,'EP21EXA0$10EEV','EP21EXA0$10ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21EX',0,60,'EP21EXA60$0EEM','EP21EXA60$0ERM',10,75,'EP21EXA60$0EEV','EP21EXA60$0ERV');
		Insert Into CPFTableComponent (CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,ErOrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('EP21EX',10,60,'EP21EXA60$10EEM','EP21EXA60$10ERM',9999999,75,'EP21EXA60$10EEV','EP21EXA60$10ERV');

	end if;

	/* Update FormulaType, Formula, UserDef1, UserDef2 and UserDef3 based on formula of previous year if formula type is T1, T2 or T3. */
	if exists(select * from SubRegistry where RegistryId = 'PaySetupData' and SubRegistryId = 'EPFProgSchemeId' and ShortStringAttr = 'EPFManVol') then
		update CPFTableCode set CPFSchemeId = 'EPFManVol' from (
			select replace(CPFTableCodeId, '20', '21') as EPFTableCodeId from CPFTableCode
			where CPFTableCodeId in ('EP20ST', 'EP20PR', 'EP20EX') and CPFSchemeId = 'EPFManVol') a
		where CPFTableCodeId = a.EPFTableCodeId;
		update Formula set FormulaType = a.FType from (
			select replace(f.FormulaId, '20', '21') as FId, f.FormulaType as FType from Formula f
			join CPFTableComponent ctc on f.FormulaId in (ctc.EEOrdCPFFormula, ctc.EROrdCPFFormula, ctc.EEAddCPFFormula, ctc.ERAddCPFFormula)
			join CPFTableCode cc on ctc.CPFTableCodeId = cc.CPFTableCodeId
			where cc.CPFTableCodeId in ('EP20ST', 'EP20PR', 'EP20EX') and cc.CPFSchemeId = 'EPFManVol' and f.FormulaType not in ('T4', 'Adv') and f.FormulaId like 'EP20%A%$%E%') a
		where FormulaId = a.FId and FormulaType not in ('T4', 'Adv');
		update FormulaRange set Formula = a.Fm, UserDef1 = a.UDef1, UserDef2 = a.UDef2, UserDef3 = a.UDef3 from (
			select replace(fr.FormulaId, '20', '21') as FId, fr.Formula as Fm, fr.UserDef1 as UDef1, fr.UserDef2 as UDef2, fr.UserDef3 as UDef3
			from FormulaRange fr join Formula f on fr.FormulaId = f.FormulaId
			join CPFTableComponent ctc on f.FormulaId in (ctc.EEOrdCPFFormula, ctc.EROrdCPFFormula, ctc.EEAddCPFFormula, ctc.ERAddCPFFormula)
			join CPFTableCode cc on ctc.CPFTableCodeId = cc.CPFTableCodeId
			where cc.CPFTableCodeId in ('EP20ST', 'EP20PR', 'EP20EX') and cc.CPFSchemeId = 'EPFManVol' and f.FormulaType not in ('T4', 'Adv') and fr.FormulaId like 'EP20%A%$%E%') a
		where FormulaId = a.FId and (select FormulaType from Formula where FormulaId = a.FId) not in ('T4', 'Adv');
	end if;

	/*-----------------------------------------------------------------------------------------------------------
		EPF Progression
	-----------------------------------------------------------------------------------------------------------*/
	update EPFProgression set EPFProgPolicyId = 'EPFYr2021Jan' where EPFEffectiveDate >= '2021-01-01' and EPFProgPolicyId = 'EPFYr2020Apr' and EPFProgSchemeId <> '';

	insert into EPFProgression(EmployeeSysId,
		EPFEffectiveDate,
		EPFCareerId,
		EPFProgPolicyId,
		EPFProgSchemeId,
		EPFEEVolPercent,
		EPFERVolPercent,
		EPFEEVolAmt,
		EPFERVolAmt,
		EPFProgRemarks,
		EPFProgCurrent)
	select EP1.EmployeeSysId,
		'2021-01-01',
		'',
		'EPFYr2021Jan',
		EP1.EPFProgSchemeId,
		EP1.EPFEEVolPercent,
		EP1.EPFERVolPercent,
		EP1.EPFEEVolAmt,
		EP1.EPFERVolAmt,
		'',
		0
	from EPFProgression EP1
	join PayEmployee PE on EP1.EmployeeSysId = PE.EmployeeSysId
	left join EPFProgression EP2 on EP1.EmployeeSysId = EP2.EmployeeSysId and EP2.EPFEffectiveDate >= '2021-01-01'
	where EP1.EPFEffectiveDate < '2021-01-01' and EP1.EPFProgCurrent = 1 and
		EP1.EPFProgPolicyId <> '' and EP1.EPFProgSchemeId <> '' and EP2.EmployeeSysId is null
		and (PE.LastPayDate = '1899-12-30' or PE.LastPayDate >= '2021-01-01');
end if;

/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/